Codeforces 216D Spider's Web 树状数组+模拟

题目链接:http://codeforces.com/problemset/problem/216/D

题意:

对于一个梯形区域,如果梯形左边的点数!=梯形右边的点数,那么这个梯形为红色,否则为绿色,

问:

给定的蜘蛛网中有多少个红色。

2个树状数组维护2个线段。然后暴力模拟一下,因为点数很多但需要用到的线段树只有3条,所以类似滚动数组的思想优化内存。

#include<stdio.h>
#include<iostream>
#include<string.h>
#include<algorithm>
#include<vector>
#include<set>
using namespace std;
#define N 10010
#define L(x) (x<<1)
#define R(x) (x<<1|1)
#define ll int
int maxn;
struct hehe{
	int c[100505];
	void init(){memset(c, 0, sizeof c);}
	inline int Lowbit(int x){return x&(-x);}
	void change(int i, int x)//i点增量为x
	{
		while(i <= maxn)
		{
			c[i] += x;
			i += Lowbit(i);
		}
	}
	int sum(int x){//区间求和 [1,x]
		int ans = 0;
		for(int i = x; i >= 1; i -= Lowbit(i))
			ans += c[i];
		return ans;
	}
}tree[2];
int ans;
vector<int>l,r,o;
void work(){
	if(o.size()<=1)return;
	tree[0].init(); tree[1].init();
	for(int i = 0; i < l.size(); i++)
		tree[0].change(l[i],1);
	for(int i = 0; i < r.size(); i++)
		tree[1].change(r[i],1);

	int L = o[0];
	for(int i = 1; i < o.size(); i++){
		int R = o[i];
		if(L+1<=R-1){
			int Z = tree[0].sum(R-1)-tree[0].sum(L);
			int Y = tree[1].sum(R-1)-tree[1].sum(L);
			ans += (Z!=Y);
		}
		L = R;
	}
}
vector<int>a,tmp1, red, tmp2, tmpend;
void Red(){
	red.clear();
	int HHH,EEE; scanf("%d",&HHH);
	while(HHH--){scanf("%d",&EEE);red.push_back(EEE);}
	sort(red.begin(),red.end());
}
int n;
int main(){
	int i,j,num;
	maxn = 100010;
	while(~scanf("%d",&n)){
		ans = 0;
		l.clear(); r.clear(); tmp1.clear(); a.clear();
		tmp2.clear(); tmpend.clear();
		Red();
		l = tmp1 = red;
		Red();
		tmp2 = o = red;
		for(i = 3; i <= n; i++){
			Red();
			r = red;
			if(i==n)tmpend = red;
			work();
			l = o;
			o = r;
		}
		r = tmp1;
		work();

		l = tmpend;
		o = tmp1;
		r = tmp2;
		work();
		cout<<ans<<endl;
	}
	return 0;
}
/*
3
2 1 3
3 1 3 2
3 1 3 2

ans:
0
2

*/
/*
ll n,m,k;
ll a[N];
ll gcd(ll x,ll y){
if(x>y)swap(x,y);
while(x){
y%=x;
swap(x,y);
}
return y;
}
int main(){
ll i, j, u, v, que;
while(cin>>n>>m>>k){
for(i = 1; i <= n; i++)cin>>a[i];
ll _gcd = a[1];
for(i = 2; i <= n; i++)_gcd = gcd(_gcd,a[i]);
for(i = 1; i <= n; i++)a[i]/=_gcd;

}
return 0;
}
/*

*/

Codeforces 216D Spider's Web 树状数组+模拟,布布扣,bubuko.com

Codeforces 216D Spider's Web 树状数组+模拟

时间: 2024-12-18 10:54:41

Codeforces 216D Spider's Web 树状数组+模拟的相关文章

Codeforces 12D Ball 树状数组模拟3个元素的排序

题目链接:点击打开链接 #include<stdio.h> #include<iostream> #include<string.h> #include<set> #include<vector> #include<map> #include<math.h> #include<queue> #include<string> #include<stdlib.h> #include<a

Hdu 3887树状数组+模拟栈

题目链接 Counting Offspring Time Limit: 15000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 1757    Accepted Submission(s): 582 Problem Description You are given a tree, it’s root is p, and the node is numbered fr

codeforces 570 D. Tree Requests 树状数组+dfs搜索序

链接:http://codeforces.com/problemset/problem/570/D D. Tree Requests time limit per test 2 seconds memory limit per test 256 megabytes input standard input output standard output Roman planted a tree consisting of n vertices. Each vertex contains a low

Codeforces 635D Factory Repairs【树状数组】

又是看了很久的题目... 题目链接: http://codeforces.com/contest/635/problem/D 题意: 一家工厂生产维修之前每天生产b个,维修了k天之后每天生产a个,维修期间不生产. 若干操作: 1. 1 d aa 第d天要求aa个订单,一个订单对应一个物品,必须在这一天中完成. 2. 2 d 第d天开始维修,最终能得到多少订单. 分析: 树状数组分别维护维修前和维修后得到的订单数,这样对于不同的维修日期,把这两种相加即可. 代码: #include<cstdio>

codeforces 597C C. Subsequences(dp+树状数组)

题目链接: C. Subsequences time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output For the given sequence with n different elements find the number of increasing subsequences with k + 1 elements. It is

CodeForces 540E - Infinite Inversions(离散化+树状数组)

花了近5个小时,改的乱七八糟,终于A了. 一个无限数列,1,2,3,4,...,n....,给n个数对<i,j>把数列的i,j两个元素做交换.求交换后数列的逆序对数. 很容易想到离散化+树状数组,但是发现那些没有交换的数也会产生逆序对数,但我没有算. 经明神提示, 把没有用到的数字段化成点.然后用树状数组算一下就好了. 然后我用一个数组记录每个点的长度.比如 <1,2><5,6>,1,2,3,4,5,6只有1,2,5,6用到了,那么离散化为1,2,3,4,5,f[1]=

Codeforces 486E LIS of Sequence --树状数组

题意: 一个序列可能有多个最长子序列,现在问每个元素是以下三个种类的哪一类: 1.不属于任何一个最长子序列 2.属于其中某些但不是全部最长子序列 3.属于全部最长子序列 解法: 我们先求出dp1[i]表示1~i 的最长递增子序列长度, dp2[i]表示 n~i 的最长递减子序列长度(严格增减),这里我们可以用维护最大值的树状数组来解决,开始还以为要用nlogn求LIS的那种算法,当然那样应该也可以,这里元素值是1~10^5的,可以直接用树状数组,如果元素值任意的话,我们离散化一下也可以用树状数组

codeforces 652D Nested Segments 离散化+树状数组

题意:给你若干个区间,询问每个区间包含几个其它区间 分析:区间范围比较大,然后离散化,按右端点排序,每次更新树状数组中的区间左端点,查询区间和 注:(都是套路) #include<cstdio> #include<cstring> #include<queue> #include<cstdlib> #include<algorithm> #include<vector> #include<cmath> using name

Codeforces 383C . Propagating tree【树状数组,dfs】

题目大意: 有一棵树,对这个树有两种操作:1:表示为(1 x val),在编号为x的节点上加上val,然后给x节点的每个儿子加上- val,再给每个儿子的儿子加上-(- val),一直加到没有儿子为止.2:表示为(2 x)查询x节点上的值. 做法: 由于每次修改操作修改的并不是一个值,而是很多值,那我们将该题抽象成区间修改,点查询的问题.那怎么抽象呢?可以明白的是,每次操作虽然有加有减,但是每次做加法操作,或者减法操作的都是同一部分数(也就是说,在某次加上同一个数的节点们,下次操作一定是加上或者